#ifndef __TYPE_DEF_H_
#define __TYPE_DEF_H_

//========================================================================
//                               Ͷ
//========================================================================

typedef bit                 BOOL;       //  2 bits 

typedef unsigned char       BYTE;       //  8 bits 
typedef unsigned int        WORD;       // 16 bits 
typedef unsigned long       DWORD;      // 32 bits 

typedef unsigned char       uchar;      //  8 bits 
typedef unsigned int        uint;       // 16 bits 
typedef unsigned int        ushor;      // 16 bits 
typedef unsigned long       ulong;      // 32 bits 

typedef unsigned char       u8;         //  8 bits 
typedef unsigned int        u16;        // 16 bits 
typedef unsigned long       u32;        // 32 bits 
// typedef unsigned long long  u64;        // 64 bits 

typedef signed char         s8;         //  8 bits 
typedef signed int          s16;        // 16 bits 
typedef signed long         s32;        // 32 bits 
// typedef signed long long    s64;        // 64 bits 

typedef unsigned char       uint8_t;    //  8 bits 
typedef unsigned int        uint16_t;   // 16 bits 
typedef unsigned long       uint32_t;   // 32 bits 
// typedef unsigned long long  uint64_t;   // 64 bits 

typedef unsigned char       uint8;      //  8 bits 
typedef unsigned int        uint16;     // 16 bits 
typedef unsigned long       uint32;     // 32 bits 
// typedef unsigned long long  uint64;     // 64 bits 

typedef signed char         int8;       //  8 bits 
typedef signed int          int16;      // 16 bits 
typedef signed long         int32;      // 32 bits
// typedef signed long long    int64;      // 64 bits

//========================================================================

// ѧ
#define PI          3.1415926535897932384626433832795
#define HALF_PI     1.5707963267948966192313216916398
#define TWO_PI      6.283185307179586476925286766559
#define DEG_TO_RAD  0.017453292519943295769236907684886
#define RAD_TO_DEG  57.295779513082320876798154814105
#define EULER       2.718281828459045235360287471352

// LCDTFTģʽ
#define MODE_8bit   0
#define MODE_16bit  1

// Ӳģʽ
#define SOFTWARE    0
#define HARDWARE    1

// TFTӿģʽ
#define MODE_I8080  0
#define MODE_M6800  1

// EEPROMģʽ
#define IAP     0   // ʹIAPķʽ
#define AT24    1   // ʹAT24CXXķʽ

//========================================================================

#define    TRUE     1
#define    FALSE    0

//========================================================================

#ifndef NULL
    #define NULL ((void *) 0L)
#endif

#ifndef Null
    #define Null ((void *) 0L)
#endif


//========================================================================

#define    Priority_0            0    //жȼΪ 0 ͼ
#define    Priority_1            1    //жȼΪ 1 ϵͼ
#define    Priority_2            2    //жȼΪ 2 ϸ߼
#define    Priority_3            3    //жȼΪ 3 ߼

#define ENABLE      1
#define DISABLE     0

#define SUCCESS     0
#define FAIL        -1

//========================================================================

// 
#define _constrain(amt,low,high) ((amt)<(low)?(low):((amt)>(high)?(high):(amt)))
// Ƕת
#define _radians(deg) ((deg)*DEG_TO_RAD)
// תǶ
#define _degrees(rad) ((rad)*RAD_TO_DEG)
// ƽ
#define _sq(x) ((x)*(x))
// ȡСֵ
#define _min(a,b) ((a)<(b)?(a):(b))
// ȡϴֵ
#define _max(a,b) ((a)>(b)?(a):(b))

// bit
#define _bitRead(value, bit) (((value) >> (bit)) & 0x01)
// bitд1
#define _bitSet(value, bit) ((value) |= (1UL << (bit)))
// bitд0
#define _bitClear(value, bit) ((value) &= ~(1UL << (bit)))
// bitд
#define _bitWrite(value, bit, bitvalue) ((bitvalue) ? bitSet(value, bit) : bitClear(value, bit))

// ȡλ
#define _lowByte(w) ((uint8_t) ((w) & 0xff))
// ȡλ
#define _highByte(w) ((uint8_t) ((w) >> 8))

// Ԫصĸ
#define  _ARR_SIZE( a )  ( sizeof( (a) ) / sizeof( (a[0]) ) )


//========================================================================
#endif
