#include "myuart.h"


//------------------------------------------------------------

u8   xdata   TX1_Cnt;    // ͼ
u8   xdata   RX1_Cnt;    // ռ
bit  xdata   B_TX1_Busy; // æ־
u8   xdata   RX1_Buffer[UART1_BUF_LENGTH]; // ջ

//-----------------------------------------------------------

#ifdef UART1
void TX1_write2buff(u8 dat)    //1ͺ
{
    SBUF = dat;
    B_TX1_Busy = 1;
    while(B_TX1_Busy);
}
#endif


//========================================================================
// : void PrintString1(u8 *puts)
// : 1ַ
// : puts:  ַָ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
#ifdef UART1
void PrintString1(u8 *puts)
{
    for (; *puts != 0;  puts++)     //ֹͣ0
    {
        TX1_write2buff(*puts);
    }
}
#endif


#ifdef printf_UART1
char putchar(char c)
{
    TX1_write2buff(c);
    return c;
}
#endif


void Uart1_printf(char *format, ...)
{
    char String[UART1_BUF_LENGTH];			//ַ
	va_list arg;							//ɱб͵ıarg
	va_start(arg, format);					//formatʼղбarg
	vsprintf(String, format, arg);			//ʹvsprintfӡʽַͲбַ
	va_end(arg);							//arg
    
    #ifdef UART1
    PrintString1(String);
    #endif
}

#ifdef UART1
//========================================================================
// : SetTimer2Baudraye(u32 dat)
// : Timer2ʷ
// : dat: Timer2װֵ.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void SetTimer2Baudraye(u32 dat)
{
	
    T2R = 0;        //Timer stop
    T2_CT = 0;    //Timer2 set As Timer
    T2x12 = 1;    //Timer2 set as 1T mode
    T2H = (u8)(dat / 256);
    T2L = (u8)(dat % 256);
    ET2 = 0;    //ֹж
    T2R = 1;        //Timer run enable
}
#endif

//========================================================================
// : void UART1_config(u8 brt)
// : UART1ʼ
// : brt: ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
void UART1_Init(u8 brt ,u32 Baudrate)
{
	#ifdef UART1
    /*********** ʹöʱ2 *****************/
    if(brt == 2)
    {
        S1BRT = 1;      //S1 BRT Use Timer2;
        SetTimer2Baudraye( (65536 - MAIN_Fosc / Baudrate / 4) );
    }

    /*********** ʹöʱ1 *****************/
    else
    {
        TR1 = 0;
        S1BRT = 0;      // 1ѡʱ1Ϊʷ
        T1_CT = 0;      // Timer1 set As Timer
        T1x12 = 1;      // ʱʱ1Tģʽ
        TMOD &= ~0x30;//Timer1_16bitAutoReload;
        TH1 = (u8)( (65536 - MAIN_Fosc / Baudrate / 4) / 256);
        TL1 = (u8)( (65536 - MAIN_Fosc / Baudrate / 4) % 256);
        ET1 = 0;    //ֹж
        TR1 = 1;
    }
    /*************************************************/

    SCON = (SCON & 0x3f) | 0x40;    //UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
//  PS  = 1;    //ȼж
    ES  = 1;    //ж
    REN = 1;    //
    P_SW1 &= 0x3f;
    P_SW1 |= 0x00;      //UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4

    B_TX1_Busy = 0;
    TX1_Cnt = 0;
    RX1_Cnt = 0;
    
	#endif
}


//========================================================================
// : void UART1_int (void) interrupt UART1_VECTOR
// : UART1жϺ
// : nine.
// : none.
// 汾: VER1.0
// : 2014-11-28
// ע: 
//========================================================================
#ifdef UART1
void UART1_int (void) interrupt 4
{
    if(RI)
    {
        RI = 0;
        RX1_Buffer[RX1_Cnt] = SBUF;
        if(++RX1_Cnt >= UART1_BUF_LENGTH)   RX1_Cnt = 0;
    }

    if(TI)
    {
        TI = 0;
        B_TX1_Busy = 0;
    }
}
#endif
